diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java b/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java
new file mode 100644
index 000000000..570450958
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java
@@ -0,0 +1,109 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntityActivator;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.EntityFallingBlock;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.collection.NamespaceID;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.util.phys.BoundingVolume;
+import net.minecraft.core.util.phys.HitResult;
+import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.ArrayList;
+import java.util.Random;
+
+interface BlockInterface {
+
+    int id();
+    @NotNull String getKey();
+    @NotNull NamespaceID namespaceId();
+
+    boolean isCubeShaped();
+    boolean canPlaceOnSurface();
+    boolean canPlaceOnSurfaceOnCondition(World world, int x, int y, int z);
+    boolean renderAsNormalBlockOnCondition(WorldSource world, int x, int y, int z);
+    boolean canPlaceOnSurfaceOfBlock(World world, int x, int y, int z);
+    /**
+     * Make sure if this gets overridden in a block that {@link net.minecraft.core.block.Block#getBreakResult(World, EnumDropCause, int, TileEntity)} also has a valid method since {@link EntityFallingBlock EntityFallingBlock} uses it!
+     */
+    ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity);
+    ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity);
+    AABB getBounds();
+    AABB getBoundsRaw();
+    float getBlockBrightness(WorldSource blockAccess, int x, int y, int z);
+    int getLightmapCoord(WorldSource blockAccess, int x, int y, int z);
+    /**
+     * Used when fullbright or lightmap is active
+     */
+    float getAmbientOcclusionStrength(WorldSource blockAccess, int x, int y, int z);
+    boolean getIsBlockSolid(WorldSource blockAccess, int x, int y, int z, Side side);
+    AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z);
+    BoundingVolume getBoundingVolume(World world, int x, int y, int z);
+    void getCollidingBoundingBoxes(World world, int x, int y, int z, AABB aabb, ArrayList<AABB> aabbList);
+    boolean collidesWithEntity(Entity entity, World world, int x, int y, int z);
+    AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z);
+    boolean isSolidRender();
+    boolean blocksLight();
+    boolean canCollideCheck(int meta, boolean shouldCollideWithFluids);
+    boolean isCollidable();
+    void updateTick(World world, int x, int y, int z, Random rand);
+    void animationTick(World world, int x, int y, int z, Random rand);
+    void onNeighborBlockChange(World world, int x, int y, int z, int blockId);
+    int tickDelay();
+    void onBlockPlacedByWorld(World world, int x, int y, int z);
+    /**
+     * Always called when a block is removed by setBlock
+     */
+    void onBlockRemoved(World world, int x, int y, int z, int data);
+    /**
+     * Called when a block has been broken by a player, after {@link net.minecraft.core.block.Block#onBlockRemoved(World, int, int, int, int)}
+     */
+    void onBlockDestroyedByPlayer(World world, int x, int y, int z, Side side, int meta, Player player, Item item);
+    float blockStrength(World world, int x, int y, int z, Side side, Player player);
+    boolean getImmovable();
+    float getBlastResistance(Entity entity);
+    HitResult collisionRayTrace(World world, int x, int y, int z, Vec3 start, Vec3 end, boolean useSelectorBoxes);
+    void onBlockDestroyedByExplosion(World world, int x, int y, int z);
+    boolean canPlaceBlockOnSide(World world, int x, int y, int z, Side side);
+    boolean canPlaceBlockAt(World world, int x, int y, int z);
+    boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit);
+    void onActivatorInteract(World world, int x, int y, int z, TileEntityActivator activator, Direction direction);
+    void onEntityWalking(World world, int x, int y, int z, Entity entity);
+    void onBlockLeftClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit);
+    void handleEntityInside(World world, int x, int y, int z, Entity entity, Vec3 entityVelocity);
+    AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z);
+    /**
+     * Gets the redstone signal output by the block itself, i.e. the power it will provide to any immediately adjacent redstone components.
+     */
+    boolean getSignal(WorldSource worldSource, int x, int y, int z, Side side);
+    boolean isSignalSource();
+    void onEntityCollidedWithBlock(World world, int x, int y, int z, Entity entity);
+    /**
+     * Gets the redstone signal pushed into adjacent solid blocks. Any block experiencing *direct* signal will power itself and all adjacent blocks.
+     */
+    boolean getDirectSignal(World world, int x, int y, int z, Side side);
+    void harvestBlock(World world, Player player, int x, int y, int z, int meta, TileEntity tileEntity);
+    void dropBlockWithCause(World world, EnumDropCause cause, int x, int y, int z, int meta, TileEntity tileEntity, Player player);
+    ISupport getSupport(World world, int x, int y, int z, Side side);
+    boolean canBlockStay(World world, int x, int y, int z);
+    void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double xPlaced, double yPlaced);
+    void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced);
+    String getLanguageKey(int meta);
+    void triggerEvent(World world, int x, int y, int z, int index, int data);
+    int getPistonPushReaction(World world, int x, int y, int z);
+    int getPlacedBlockMetadata(@Nullable Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced);
+    boolean isClimbable(World world, int x, int y, int z);
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
new file mode 100644
index 000000000..b617efc66
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogic.java
@@ -0,0 +1,507 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.achievement.stat.StatList;
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntityActivator;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.MaterialColor;
+import net.minecraft.core.block.support.FullSupport;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.EntityItem;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.IItemConvertible;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.tool.ItemToolShears;
+import net.minecraft.core.util.collection.NamespaceID;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.util.phys.BoundingVolume;
+import net.minecraft.core.util.phys.HitResult;
+import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.ArrayList;
+import java.util.Objects;
+import java.util.Random;
+
+public class BlockLogic implements BlockInterface, IItemConvertible {
+    protected final AABB bounds = AABB.getPermanentBB(0, 0, 0, 1, 1, 1);
+    public final @NotNull Block<?> block;
+    protected @NotNull Material material;
+    public BlockLogic(Block<?> block, Material material) {
+        this.block = Objects.requireNonNull(block);
+        this.material = Objects.requireNonNull(material);
+    }
+
+    public void initializeBlock() {
+
+    }
+
+    @Override
+    public final int id() {
+        return block.id();
+    }
+
+    @Override
+    public final @NotNull String getKey() {
+        return block.getKey();
+    }
+
+    @Override
+    public final @NotNull NamespaceID namespaceId() {
+        return block.namespaceId();
+    }
+
+    public @NotNull Material getMaterial() {
+        return material;
+    }
+
+    public @NotNull MaterialColor getMaterialColor() {
+        return material.color;
+    }
+
+    @Override
+    public boolean isCubeShaped() {
+        return true;
+    }
+
+    @Override
+    public boolean canPlaceOnSurface() {
+        return this.isCubeShaped();
+    }
+
+    @Override
+    public boolean canPlaceOnSurfaceOnCondition(World world, int x, int y, int z) {
+        return this.canPlaceOnSurface();
+    }
+
+    @Override
+    public boolean renderAsNormalBlockOnCondition(WorldSource world, int x, int y, int z) {
+        return this.isCubeShaped();
+    }
+
+    @Override
+    public boolean canPlaceOnSurfaceOfBlock(World world, int x, int y, int z) {
+        return canPlaceOnSurface();
+    }
+
+    @Override
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity) {
+        return getBreakResult(world, dropCause, meta, tileEntity);
+    }
+
+    @Override
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity) {
+        if (dropCause != EnumDropCause.IMPROPER_TOOL) {
+            return new ItemStack[] { new ItemStack(block) };
+        }
+        return null;
+    }
+
+    public void setBlockBounds(double minX, double minY, double minZ, double maxX, double maxY, double maxZ)
+    {
+        bounds.set(minX, minY, minZ, maxX, maxY, maxZ);
+    }
+
+    @Override
+    public AABB getBounds() {
+        return bounds.copy();
+    }
+
+    @Override
+    public AABB getBoundsRaw() {
+        return bounds;
+    }
+
+    @Override
+    public float getBlockBrightness(WorldSource blockAccess, int x, int y, int z) {
+        return blockAccess.getBrightness(x, y, z, block.emission);
+    }
+
+    @Override
+    public int getLightmapCoord(WorldSource blockAccess, int x, int y, int z) {
+        return blockAccess.getLightmapCoord(x, y, z, block.emission);
+    }
+
+    @Override
+    public float getAmbientOcclusionStrength(WorldSource blockAccess, int x, int y, int z) {
+        return isSolidRender() ? 1.0f : 0.0f;
+    }
+
+    @Override
+    public boolean getIsBlockSolid(WorldSource blockAccess, int x, int y, int z, Side side) {
+        return blockAccess.getBlockMaterial(x, y, z).isSolid();
+    }
+
+    @Override
+    public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z) {
+        return getBlockBoundsFromState(world, x, y, z).move(x, y, z);
+    }
+
+    @Override
+    public BoundingVolume getBoundingVolume(World world, int x, int y, int z) {
+        return null;
+    }
+
+    @Override
+    public void getCollidingBoundingBoxes(World world, int x, int y, int z, AABB aabb, ArrayList<AABB> aabbList)
+    {
+        addIntersectingBoundingBox(aabb, getCollisionBoundingBoxFromPool(world, x, y, z), aabbList);
+    }
+
+    protected void addIntersectingBoundingBox(AABB sourceAABB, AABB aabbToAdd, ArrayList<AABB> aabbList) {
+        if(aabbToAdd != null && sourceAABB.intersects(aabbToAdd))
+        {
+            aabbList.add(aabbToAdd);
+        }
+    }
+
+    @Override
+    public boolean collidesWithEntity(Entity entity, World world, int x, int y, int z) {
+        return true;
+    }
+
+    @Override
+    public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z) {
+        return getBlockBoundsFromState(world, x, y, z).move(x, y, z);
+    }
+
+    @Override
+    public boolean isSolidRender() {
+        return true;
+    }
+
+    @Override
+    public boolean blocksLight() {
+        return false;
+    }
+
+    @Override
+    public boolean canCollideCheck(int meta, boolean shouldCollideWithFluids) {
+        return isCollidable();
+    }
+
+    @Override
+    public boolean isCollidable() {
+        return true;
+    }
+
+    @Override
+    public void updateTick(World world, int x, int y, int z, Random rand) {
+
+    }
+
+    @Override
+    public void animationTick(World world, int x, int y, int z, Random rand) {
+
+    }
+
+    @Override
+    public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
+
+    }
+
+    @Override
+    public int tickDelay() {
+        return 10;
+    }
+
+    @Override
+    public void onBlockPlacedByWorld(World world, int x, int y, int z) {
+
+    }
+
+    @Override
+    public void onBlockRemoved(World world, int x, int y, int z, int data) {
+
+    }
+
+    @Override
+    public void onBlockDestroyedByPlayer(World world, int x, int y, int z, Side side, int meta, Player player, Item item) {
+
+    }
+
+    @Override
+    public float blockStrength(World world, int x, int y, int z, Side side, Player player) {
+        if(block.blockHardness < 0.0F)
+        {
+            return 0.0F;
+        }
+
+        if (!player.canHarvestBlock(block))
+        {
+            return 1.0F / block.blockHardness / 100F;
+        }
+        else
+        {
+            return player.getCurrentPlayerStrVsBlock(block) / block.blockHardness / 30F;
+        }
+    }
+
+    @Override
+    public boolean getImmovable() {
+        return block.immovable;
+    }
+
+    @Override
+    public float getBlastResistance(Entity entity) {
+        return block.blastResistance / 5f;
+    }
+
+    @Override
+    public HitResult collisionRayTrace(World world, int x, int y, int z, Vec3 start, Vec3 end, boolean useSelectorBoxes) {
+        AABB bounds = useSelectorBoxes ? getSelectedBoundingBoxFromPool(world, x, y, z).move(-x, -y, -z) : getBlockBoundsFromState(world, x, y, z);
+        start = start.add(-x, -y, -z);
+        end = end.add(-x, -y, -z);
+        Vec3 minVX = start.clipX(end, bounds.minX);
+        Vec3 maxVX = start.clipX(end, bounds.maxX);
+        Vec3 minVY = start.clipY(end, bounds.minY);
+        Vec3 maxVY = start.clipY(end, bounds.maxY);
+        Vec3 minVZ = start.clipZ(end, bounds.minZ);
+        Vec3 maxVZ = start.clipZ(end, bounds.maxZ);
+
+        if(!isVecInsideYZBounds(bounds,minVX)) minVX = null;
+        if(!isVecInsideYZBounds(bounds,maxVX)) maxVX = null;
+        if(!isVecInsideXZBounds(bounds,minVY)) minVY = null;
+        if(!isVecInsideXZBounds(bounds,maxVY)) maxVY = null;
+        if(!isVecInsideXYBounds(bounds,minVZ)) minVZ = null;
+        if(!isVecInsideXYBounds(bounds,maxVZ)) maxVZ = null;
+
+        Vec3 vec38 = null;
+        if(minVX != null && (vec38 == null || start.distanceToSquared(minVX) < start.distanceToSquared(vec38))) vec38 = minVX;
+        if(maxVX != null && (vec38 == null || start.distanceToSquared(maxVX) < start.distanceToSquared(vec38))) vec38 = maxVX;
+        if(minVY != null && (vec38 == null || start.distanceToSquared(minVY) < start.distanceToSquared(vec38))) vec38 = minVY;
+        if(maxVY != null && (vec38 == null || start.distanceToSquared(maxVY) < start.distanceToSquared(vec38))) vec38 = maxVY;
+        if(minVZ != null && (vec38 == null || start.distanceToSquared(minVZ) < start.distanceToSquared(vec38))) vec38 = minVZ;
+        if(maxVZ != null && (vec38 == null || start.distanceToSquared(maxVZ) < start.distanceToSquared(vec38))) vec38 = maxVZ;
+
+        if(vec38 == null) return null;
+        Side side = Side.NONE;
+        if(vec38 == minVX) side = Side.WEST;
+        if(vec38 == maxVX) side = Side.EAST;
+        if(vec38 == minVY) side = Side.BOTTOM;
+        if(vec38 == maxVY) side = Side.TOP;
+        if(vec38 == minVZ) side = Side.NORTH;
+        if(vec38 == maxVZ) side = Side.SOUTH;
+
+        return new HitResult(x, y, z, side, vec38.add(x, y, z));
+    }
+
+    private boolean isVecInsideYZBounds(AABB bounds, @Nullable Vec3 vec3)
+    {
+        if(vec3 == null) {
+            return false;
+        }
+        return vec3.y >= bounds.minY && vec3.y <= bounds.maxY && vec3.z >= bounds.minZ && vec3.z <= bounds.maxZ;
+    }
+
+    private boolean isVecInsideXZBounds(AABB bounds, @Nullable Vec3 vec3)
+    {
+        if(vec3 == null) {
+            return false;
+        }
+        return vec3.x >= bounds.minX && vec3.x <= bounds.maxX && vec3.z >= bounds.minZ && vec3.z <= bounds.maxZ;
+    }
+
+    private boolean isVecInsideXYBounds(AABB bounds, @Nullable Vec3 vec3)
+    {
+        if(vec3 == null) {
+            return false;
+        }
+        return vec3.x >= bounds.minX && vec3.x <= bounds.maxX && vec3.y >= bounds.minY && vec3.y <= bounds.maxY;
+    }
+
+    @Override
+    public void onBlockDestroyedByExplosion(World world, int x, int y, int z) {
+
+    }
+
+    @Override
+    public boolean canPlaceBlockOnSide(World world, int x, int y, int z, Side side) {
+        return canPlaceBlockAt(world, x, y, z);
+    }
+
+    @Override
+    public boolean canPlaceBlockAt(World world, int x, int y, int z) {
+        return world.canPlaceInsideBlock(x, y, z);
+    }
+
+    @Override
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit) {
+        return false;
+    }
+
+    @Override
+    public void onActivatorInteract(World world, int x, int y, int z, TileEntityActivator activator, Direction direction) {
+
+    }
+
+    @Override
+    public void onEntityWalking(World world, int x, int y, int z, Entity entity) {
+
+    }
+
+    @Override
+    public void onBlockLeftClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit) {
+
+    }
+
+    @Override
+    public void handleEntityInside(World world, int x, int y, int z, Entity entity, Vec3 entityVelocity) {
+
+    }
+
+    @Override
+    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z) {
+        return getBounds();
+    }
+
+    @Override
+    public boolean getSignal(WorldSource worldSource, int x, int y, int z, Side side) {
+        return false;
+    }
+
+    @Override
+    public boolean isSignalSource() {
+        return false;
+    }
+
+    @Override
+    public void onEntityCollidedWithBlock(World world, int x, int y, int z, Entity entity) {
+
+    }
+
+    @Override
+    public boolean getDirectSignal(World world, int x, int y, int z, Side side) {
+        return false;
+    }
+
+    @Override
+    public void harvestBlock(World world, Player player, int x, int y, int z, int meta, TileEntity tileEntity) {
+        player.addStat(block.getStat(StatList.STAT_MINED), 1);
+
+        ItemStack heldItemStack = player.inventory.getCurrentItem();
+        Item heldItem = heldItemStack != null ? Item.itemsList[heldItemStack.itemID] : null;
+
+        if (heldItem != null)
+        {
+            if (heldItem.isSilkTouch() && player.canHarvestBlock(block))
+            {
+                dropBlockWithCause(world, EnumDropCause.SILK_TOUCH, x, y, z, meta, tileEntity, player);
+                return;
+            }
+            else if (heldItem instanceof ItemToolShears && (block.hasTag(BlockTags.SHEARS_DO_SILK_TOUCH) || block.hasTag(BlockTags.MINEABLE_BY_SHEARS)))
+            {
+                ItemToolShears heldShears = (ItemToolShears) heldItem;
+                dropBlockWithCause(world, EnumDropCause.SILK_TOUCH, x, y, z, meta, tileEntity, player);
+                heldShears.onBlockSheared(player, heldItemStack);
+                return;
+            }
+        }
+
+        if (player.canHarvestBlock(block))
+        {
+            dropBlockWithCause(world, EnumDropCause.PROPER_TOOL, x, y, z, meta, tileEntity, player);
+        }
+        else
+        {
+            dropBlockWithCause(world, EnumDropCause.IMPROPER_TOOL, x, y, z, meta, tileEntity, player);
+        }
+    }
+
+    @Override
+    public void dropBlockWithCause(World world, EnumDropCause cause, int x, int y, int z, int meta, TileEntity tileEntity, Player player) {
+        if(world.isClientSide)
+            return;
+
+        ItemStack[] drops = getBreakResult(world, cause, x, y, z, meta, tileEntity);
+        if (drops == null) {
+            return;
+        }
+        for (int j = 0, dropsLength = drops.length; j < dropsLength; j++) {
+            ItemStack drop = drops[j];
+            if (drop == null) {
+                continue;
+            }
+            if (block.hasTag(BlockTags.INSTANT_PICKUP) && player != null) {
+                player.inventory.insertItem(drop, true);
+                if (drop.stackSize <= 0) {
+                    continue;
+                }
+            }
+            if (EntityItem.enableItemClumping) {
+                world.dropItem(x, y, z, drop.copy());
+            } else {
+                for (int i = 0; i < drop.stackSize; i++) {
+                    ItemStack drop1 = drop.copy();
+                    drop1.stackSize = 1;
+                    world.dropItem(x, y, z, drop1);
+                }
+            }
+        }
+    }
+
+    @Override
+    public ISupport getSupport(World world, int x, int y, int z, Side side) {
+        return FullSupport.INSTANCE;
+    }
+
+    @Override
+    public boolean canBlockStay(World world, int x, int y, int z) {
+        return true;
+    }
+
+    @Override
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double xPlaced, double yPlaced) {
+        onBlockPlacedOnSide(world, x, y, z, side, xPlaced, yPlaced);
+    }
+
+    @Override
+    public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
+
+    }
+
+    @Override
+    public String getLanguageKey(int meta) {
+        return block.getKey();
+    }
+
+    @Override
+    public void triggerEvent(World world, int x, int y, int z, int index, int data) {
+
+    }
+
+    @Override
+    public int getPistonPushReaction(World world, int x, int y, int z) {
+        return material.getPushReaction();
+    }
+
+    @Override
+    public int getPlacedBlockMetadata(@Nullable Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+        return 0;
+    }
+
+    @Override
+    public boolean isClimbable(World world, int x, int y, int z) {
+        return false;
+    }
+
+    @Override
+    public Item asItem() {
+        return block.asItem();
+    }
+
+    @Override
+    public ItemStack getDefaultStack() {
+        return block.getDefaultStack();
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockActivator.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java
similarity index 85%
rename from game/core/src/main/java/net/minecraft/core/block/BlockActivator.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java
index 703d8f102..1a7108d55 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockActivator.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java
@@ -1,7 +1,6 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntityActivator;
-import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
@@ -14,12 +13,12 @@ import net.minecraft.core.world.World;
 
 import java.util.Random;
 
-public class BlockActivator extends BlockTileEntityVeryRotatable
+public class BlockLogicActivator extends BlockLogicVeryRotatable
 {
     public static final int MASK_POWERED = 0b0000_1000;
-    public BlockActivator(String key, String namespaceId, int id)
-    {
-        super(key, namespaceId, id, Material.netherrack);
+    public BlockLogicActivator(Block<?> block) {
+        super(block, Material.netherrack);
+        block.withEntity(TileEntityActivator::new);
     }
 
     @Override
@@ -40,7 +39,7 @@ public class BlockActivator extends BlockTileEntityVeryRotatable
 
     private void useItem(World world, int x, int y, int z, Random random)
     {
-        Direction direction = BlockRotatable.getDirectionFromMeta(world.getBlockMetadata(x, y, z));
+        Direction direction = BlockLogicRotatable.getDirectionFromMeta(world.getBlockMetadata(x, y, z));
         int xOffset = direction.getOffsetX();
         int yOffset = direction.getOffsetY();
         int zOffset = direction.getOffsetZ();
@@ -54,7 +53,7 @@ public class BlockActivator extends BlockTileEntityVeryRotatable
             double pz = (double)zOffset * 0.6D + 0.5D;
             if(itemStack == null)
             {
-                Block block = world.getBlock(x + xOffset, y + yOffset, z + zOffset);
+                Block<?> block = world.getBlock(x + xOffset, y + yOffset, z + zOffset);
                 if (block != null) {
                     block.onActivatorInteract(world, x + xOffset, y + yOffset, z + zOffset, activator, direction);
                 } else {
@@ -78,10 +77,10 @@ public class BlockActivator extends BlockTileEntityVeryRotatable
     public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
         int meta = world.getBlockMetadata(x, y, z);
-        boolean flag = getNeighborSignal(world, x, y, z, BlockRotatable.getDirectionFromMeta(meta));
+        boolean flag = getNeighborSignal(world, x, y, z, BlockLogicRotatable.getDirectionFromMeta(meta));
         if(flag && (meta & MASK_POWERED) == 0)
         {
-            world.scheduleBlockUpdate(x, y, z, id, tickDelay());
+            world.scheduleBlockUpdate(x, y, z, block.id(), tickDelay());
             world.setBlockMetadata(x, y, z, meta | MASK_POWERED);
         } else if (!flag){
             world.setBlockMetadata(x, y, z, meta & ~MASK_POWERED);
@@ -118,11 +117,4 @@ public class BlockActivator extends BlockTileEntityVeryRotatable
         }
         return false;
     }
-
-    @Override
-    protected TileEntity getNewBlockEntity()
-    {
-        return new TileEntityActivator();
-    }
-
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockAlgae.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAlgae.java
similarity index 78%
rename from game/core/src/main/java/net/minecraft/core/block/BlockAlgae.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicAlgae.java
index 9fdd7944e..529407867 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockAlgae.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAlgae.java
@@ -12,12 +12,12 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.phys.AABB;
 
-public class BlockAlgae extends Block
+public class BlockLogicAlgae extends BlockLogic
 {
 
-    protected BlockAlgae(String key, String namespaceId, int id, Material material)
+    protected BlockLogicAlgae(Block<?> block, Material material)
     {
-        super(key, namespaceId, id, material);
+        super(block, material);
         setBlockBounds(0.0F, -0.125F, 0.0F, 1.0F, 0.00625f, 1.0F);
     }
 
@@ -26,7 +26,7 @@ public class BlockAlgae extends Block
     {
         if(entity instanceof EntityBoat) {
             int data = world.getBlockMetadata(x, y, z);
-            world.playBlockEvent(null, LevelListener.EVENT_BLOCK_BREAK, x, y, z, id);
+            world.playBlockEvent(null, LevelListener.EVENT_BLOCK_BREAK, x, y, z, block.id());
             world.setBlockWithNotify(x, y, z, 0);
             this.onBlockRemoved(world, x, y, z, data);
         }
@@ -36,13 +36,13 @@ public class BlockAlgae extends Block
     public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
         int blockId = world.getBlockId(x, y, z);
-        return blockId == 0 && Block.hasTag(world.getBlockId(x, y - 1, z), BlockTags.IS_WATER) && world.getBlockMetadata(x, y -1, z) == 0;
+        return blockId == 0 && Blocks.hasTag(world.getBlockId(x, y - 1, z), BlockTags.IS_WATER) && world.getBlockMetadata(x, y -1, z) == 0;
     }
 
     @Override
     public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
-        if(!Block.hasTag(world.getBlockId(x, y - 1, z), BlockTags.IS_WATER) || world.getBlockMetadata(x, y -1, z) != 0){
+        if(!Blocks.hasTag(world.getBlockId(x, y - 1, z), BlockTags.IS_WATER) || world.getBlockMetadata(x, y -1, z) != 0){
             world.setBlock(x, y, z,0);
         }
     }
@@ -72,7 +72,7 @@ public class BlockAlgae extends Block
         {
             case SILK_TOUCH:
             case PICK_BLOCK:
-                return new ItemStack[] { new ItemStack(this) };
+                return new ItemStack[] { new ItemStack(block) };
             default:
                 return null;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockAxisAligned.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAxisAligned.java
similarity index 86%
rename from game/core/src/main/java/net/minecraft/core/block/BlockAxisAligned.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicAxisAligned.java
index b18d96ae7..34fd38e5b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockAxisAligned.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAxisAligned.java
@@ -8,10 +8,10 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 
-public class BlockAxisAligned extends Block {
+public class BlockLogicAxisAligned extends BlockLogic {
 
-	public BlockAxisAligned(String key, String namespaceId, int id, Material material) {
-		super(key, namespaceId, id, material);
+	public BlockLogicAxisAligned(Block<?> block, Material material) {
+		super(block, material);
 	}
 
 	@Override
